#ifndef _MIDI_RECORDER_APP
#define _MIDI_RECORDER_APP


#include "ofMain.h"
#include "ofxMidi.h"
#include "timeEventRecorder.h"
#include "timeEvent.h"
#include "whitneyPoint.h"
#include <vector>

class MidiRecorder : public ofBaseApp, public ofxMidiListener{

public:
	void setup();
	void update();
	void draw();
	
	void keyPressed  (int key);
	void keyReleased(int key);
	void mouseMoved(int x, int y );
	void mouseDragged(int x, int y, int button);
	void mousePressed(int x, int y, int button);
	void mouseReleased(int x, int y, int button);
	void windowResized(int w, int h);
	
	void printExistingIds();
	std::string returnExistingIdsStr();
	std::string getValues(float time);
	
	void printIdValues(const vector<IdValue>& values);

	void newMidiMessage(ofxMidiEventArgs& eventArgs);
	
	void addPoints();
		
protected:
	ofxMidiIn									_midiIn;
	TimeEventRecorder					_recorder; 
	std::vector<TimeEvent>		_buffer;
	float											_master_time;
	ofTrueTypeFont						_franklin_book;
	int												_loopSeconds;	
	bool											_showTime;
	std::vector<WhitneyPoint> _points;
	
	int												_width;
	int												_height;
	
	
	void testRecorder();

};

#endif
