/*
 *  point.h
 *  johnWhitney
 *
 *  Created by Lucas Vickers on 9/20/10.
 *  Copyright 2010 None. All rights reserved.
 *
 */

#ifndef WHITNEY_POINT_H
#define WHITNEY_POINT_H

#include "ofMain.h"
#include "particle.h"

class WhitneyPoint
{

protected:
	float		drawRadius;					// how big is the circle we draw, for ofCircle
	float		drawRadiusPct;			// what % the circle should grow by
	float		rotationRadius;			// orbital radius, how far from the origin is this circle
	float		rotationRadiusPct;	// percentage of rotation radius we will be at
	ofPoint	origin;							// where do we rotate around, the rotational center
	ofPoint currentOrigin;			// we can shake the origin
	float		rotationSpeed;			// speed at which we rotate.  dependent on time
	float		rotationSpeedPct;		// adjust speed;
	ofPoint curLocation;				// current location
	
	// more advanced cool stuff
	float		RRModulation;				// rotationRadius amplitude modulation
	ofColor color;							// currentColor
	ofColor curColor;						// updated color, currently unused
	float		angleOffset;				// cause point to be offset
	
	float anglePosition;				// movement, in conjunction w/ time
	float lastUpdateTime;
	
	vector <particle*> myParticles;
	int numParticles;
	
public:
	WhitneyPoint(float drawRadius, 
							 float rotationRadius, 
							 ofPoint origin, 
							 float rotationSpeed,
							 float RRModulation,
							 ofColor color,
							 float angleOffset);
	
	void update();
	void draw();
	void setShake(float shakeRadius);
	void setDrawRadiusPct(float setDrawRadiusPct);
	void setRotationRadiusPct(float setRotationRadiusPct);
	void setRotationSpeedPct(float setRotationSpeedPct);
	void setAlpha(float alpha);
};

#endif
